﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Infragistics.Controls.Menus;
using System.Collections;

namespace FontDropDownInRibbon
{
    public class ComboBoxTool : RibbonTool
    {
        protected override RibbonToolBaseControl ResolveToolControl()
        {
            return new ComboBoxToolControl(this); 
        }

        public IEnumerable ItemsSource
        {
            get { return (IEnumerable)GetValue(ItemsSourceProperty); }
            set { SetValue(ItemsSourceProperty, value); }
        }

        public static readonly DependencyProperty ItemsSourceProperty = 
            DependencyProperty.Register("ItemsSource", typeof(IEnumerable),
            typeof(ComboBoxTool), null);

        public String DisplayMemberPath { get; set; }

    }

    public class ComboBoxToolControl : RibbonToolBaseControl, IRibbonControl
    {
        private ComboBox _combo;

        public ComboBoxToolControl()
        {
            this.DefaultStyleKey = typeof(ComboBoxToolControl);
        }

        public ComboBoxToolControl(RibbonToolBase tool)
            : base(tool)
        {
            this.DefaultStyleKey = typeof(ComboBoxToolControl);
        }

        public override void OnApplyTemplate()
        {
            base.OnApplyTemplate();
            this._combo = GetTemplateChild("Combo") as ComboBox;
            if (this._combo != null)
            {
                this._combo.ItemsSource = ((ComboBoxTool)this.Tool).ItemsSource;
                this._combo.DisplayMemberPath = ((ComboBoxTool)this.Tool).DisplayMemberPath;
            }

        }
    }
}
